Index: .bzrignore
===================================================================
--- .bzrignore	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ .bzrignore	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -80,4 +80,5 @@
 uspace/app/wavplay/wavplay
 uspace/app/websrv/websrv
+uspace/app/wifi_supplicant/wifi_supplicant
 uspace/dist/app/barber
 uspace/dist/app/bdsh
@@ -133,5 +134,7 @@
 uspace/dist/app/wavplay
 uspace/dist/app/websrv
+uspace/dist/app/wifi_supplicant
 uspace/dist/drv/ahci/
+uspace/dist/drv/ar9271/
 uspace/dist/drv/ata_bd/
 uspace/dist/drv/cmos-rtc/
@@ -202,4 +205,5 @@
 uspace/drv/block/ahci/ahci
 uspace/drv/block/ata_bd/ata_bd
+uspace/drv/block/ddisk/ddisk
 uspace/drv/bus/isa/isa
 uspace/drv/bus/pci/pciintel/pciintel
@@ -224,4 +228,5 @@
 uspace/drv/platform/pc/pc
 uspace/drv/platform/rootpc/rootpc
+uspace/drv/nic/ar9271/ar9271
 uspace/drv/nic/e1k/e1k
 uspace/drv/nic/ne2k/ne2k
Index: abi/include/abi/proc/uarg.h
===================================================================
--- abi/include/abi/proc/uarg.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ abi/include/abi/proc/uarg.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -42,5 +42,5 @@
 	size_t uspace_stack_size;
 	
-	void (* uspace_thread_function)();
+	void (* uspace_thread_function)(void *);
 	void *uspace_thread_arg;
 	
Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ boot/Makefile.common	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -178,7 +178,4 @@
 	$(USPACE_PATH)/app/corecfg/corecfg \
 	$(USPACE_PATH)/app/devctl/devctl \
-	$(USPACE_PATH)/app/dltest/dltest \
-	$(USPACE_PATH)/app/dltest2/dltest2 \
-	$(USPACE_PATH)/app/dload/dload \
 	$(USPACE_PATH)/app/dnscfg/dnscfg \
 	$(USPACE_PATH)/app/dnsres/dnsres \
@@ -208,9 +205,4 @@
 	$(USPACE_PATH)/app/tetris/tetris \
 	$(USPACE_PATH)/app/trace/trace \
-	$(USPACE_PATH)/app/nettest1/nettest1 \
-	$(USPACE_PATH)/app/nettest2/nettest2 \
-	$(USPACE_PATH)/app/nettest3/nettest3 \
-	$(USPACE_PATH)/app/netecho/netecho \
-	$(USPACE_PATH)/app/netspeed/netspeed \
 	$(USPACE_PATH)/app/nterm/nterm \
 	$(USPACE_PATH)/app/ping/ping \
Index: boot/arch/arm32/src/mm.c
===================================================================
--- boot/arch/arm32/src/mm.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ boot/arch/arm32/src/mm.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -193,7 +193,8 @@
 }
 
-static void enable_paging()
-{
-	/* c3   - each two bits controls access to the one of domains (16)
+static void enable_paging(void)
+{
+	/*
+	 * c3   - each two bits controls access to the one of domains (16)
 	 * 0b01 - behave as a client (user) of a domain
 	 */
@@ -232,5 +233,6 @@
 
 /** Start the MMU - initialize page table and enable paging. */
-void mmu_start() {
+void mmu_start(void)
+{
 	disable_paging();
 #ifdef PROCESSOR_ARCH_armv7_a
Index: boot/arch/ppc32/include/asm.h
===================================================================
--- boot/arch/ppc32/include/asm.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ boot/arch/ppc32/include/asm.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -35,5 +35,5 @@
 extern void jump_to_kernel(void *, void *, size_t, void *)
     __attribute__((noreturn));
-extern void real_mode();
+extern void real_mode(void);
 
 #endif
Index: boot/arch/sparc32/src/ambapp.c
===================================================================
--- boot/arch/sparc32/src/ambapp.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ boot/arch/sparc32/src/ambapp.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -58,5 +58,5 @@
 static void ambapp_scan_area(uintptr_t, unsigned int);
 
-void ambapp_scan()
+void ambapp_scan(void)
 {
 	amba_fake = false;
@@ -104,5 +104,5 @@
 }
 
-void ambapp_qemu_fake_scan()
+void ambapp_qemu_fake_scan(void)
 {
 	/* UART */
@@ -134,10 +134,10 @@
 }
 
-bool ambapp_fake()
+bool ambapp_fake(void)
 {
 	return amba_fake;
 }
 
-void ambapp_print_devices()
+void ambapp_print_devices(void)
 {
 	printf("ABMA devices:\n");
Index: boot/arch/sparc32/src/mm.c
===================================================================
--- boot/arch/sparc32/src/mm.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ boot/arch/sparc32/src/mm.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -76,5 +76,5 @@
 }
 
-static void mmu_disable()
+static void mmu_disable(void)
 {
 	uint32_t cr = asi_u32_read(ASI_MMUREGS, 0x000);
Index: boot/generic/include/memstr.h
===================================================================
--- boot/generic/include/memstr.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ boot/generic/include/memstr.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -36,8 +36,11 @@
 
 extern void *memcpy(void *, const void *, size_t)
-    __attribute__ ((optimize("-fno-tree-loop-distribute-patterns")));
+    __attribute__((nonnull(1, 2)))
+    __attribute__((optimize("-fno-tree-loop-distribute-patterns")));
 extern void *memset(void *, int, size_t)
-    __attribute__ ((optimize("-fno-tree-loop-distribute-patterns")));
-extern void *memmove(void *, const void *, size_t);
+    __attribute__((nonnull(1)))
+    __attribute__((optimize("-fno-tree-loop-distribute-patterns")));
+extern void *memmove(void *, const void *, size_t)
+    __attribute__((nonnull(1, 2)));
 
 #endif
Index: kernel/arch/abs32le/src/abs32le.c
===================================================================
--- kernel/arch/abs32le/src/abs32le.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/arch/abs32le/src/abs32le.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -69,5 +69,5 @@
 }
 
-void arch_post_cpu_init()
+void arch_post_cpu_init(void)
 {
 }
Index: kernel/arch/amd64/include/arch/asm.h
===================================================================
--- kernel/arch/amd64/include/arch/asm.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/arch/amd64/include/arch/asm.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -339,5 +339,5 @@
  *
  */
-NO_TRACE static inline void enable_l_apic_in_msr()
+NO_TRACE static inline void enable_l_apic_in_msr(void)
 {
 	asm volatile (
Index: kernel/arch/amd64/src/fpu_context.c
===================================================================
--- kernel/arch/amd64/src/fpu_context.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/arch/amd64/src/fpu_context.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -54,5 +54,5 @@
 }
 
-void fpu_init()
+void fpu_init(void)
 {
 	/* TODO: Zero all SSE, MMX etc. registers */
Index: kernel/arch/arm32/include/arch/cp15.h
===================================================================
--- kernel/arch/arm32/include/arch/cp15.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/arch/arm32/include/arch/cp15.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -47,5 +47,5 @@
 
 #define CONTROL_REG_GEN_READ(name, crn, opc1, crm, opc2) \
-static inline uint32_t name##_read() \
+static inline uint32_t name##_read(void) \
 { \
 	uint32_t val; \
Index: kernel/arch/arm32/include/arch/security_ext.h
===================================================================
--- kernel/arch/arm32/include/arch/security_ext.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/arch/arm32/include/arch/security_ext.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -46,5 +46,5 @@
  * older archs.
  */
-static inline bool sec_ext_is_implemented()
+static inline bool sec_ext_is_implemented(void)
 {
 #ifdef PROCESSOR_ARCH_armv7_a
@@ -60,5 +60,5 @@
  * mode.
  */
-static inline bool sec_ext_is_monitor_mode()
+static inline bool sec_ext_is_monitor_mode(void)
 {
 	return (current_status_reg_read() & MODE_MASK) == MONITOR_MODE;
@@ -75,5 +75,5 @@
  * Look for 'secureworld_exit' in arch/arm/cpu/armv7/omap3/board.c.
  */
-static inline bool sec_ext_is_secure()
+static inline bool sec_ext_is_secure(void)
 {
 	return sec_ext_is_implemented()
Index: kernel/arch/arm32/src/arm32.c
===================================================================
--- kernel/arch/arm32/src/arm32.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/arch/arm32/src/arm32.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -158,5 +158,5 @@
 
 /** Reboot. */
-void arch_reboot()
+void arch_reboot(void)
 {
 	/* not implemented */
Index: kernel/arch/arm32/src/fpu_context.c
===================================================================
--- kernel/arch/arm32/src/fpu_context.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/arch/arm32/src/fpu_context.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -101,4 +101,5 @@
 	FPSCR_EN_ALL = FPSCR_DENORMAL_EN_FLAG | FPSCR_INEXACT_EN_FLAG | FPSCR_UNDERFLOW_EN_FLAG | FPSCR_OVERFLOW_EN_FLAG | FPSCR_ZERO_DIV_EN_FLAG | FPSCR_INVALID_OP_EN_FLAG,
 };
+
 extern uint32_t fpscr_read(void);
 extern void fpscr_write(uint32_t);
@@ -114,7 +115,8 @@
 static void (*restore_context)(fpu_context_t *ctx);
 
-static int fpu_have_coprocessor_access()
-{
-/* The register containing the information (CPACR) is not available on armv6-
+static int fpu_have_coprocessor_access(void)
+{
+/*
+ * The register containing the information (CPACR) is not available on armv6-
  * rely on user decision to use CONFIG_FPU.
  */
@@ -143,7 +145,8 @@
  * @note do we need to call secure monitor here?
  */
-static void fpu_enable_coprocessor_access()
-{
-/* The register containing the information (CPACR) is not available on armv6-
+static void fpu_enable_coprocessor_access(void)
+{
+/*
+ * The register containing the information (CPACR) is not available on armv6-
  * rely on user decision to use CONFIG_FPU.
  */
Index: kernel/arch/ia32/src/fpu_context.c
===================================================================
--- kernel/arch/ia32/src/fpu_context.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/arch/ia32/src/fpu_context.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -125,5 +125,5 @@
 
 /** Initialize x87 FPU. Mask all exceptions. */
-void fpu_init()
+void fpu_init(void)
 {
 	uint32_t help0 = 0;
Index: kernel/arch/ia64/src/mm/vhpt.c
===================================================================
--- kernel/arch/ia64/src/mm/vhpt.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/arch/ia64/src/mm/vhpt.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -82,5 +82,5 @@
 }
 
-void vhpt_invalidate_all()
+void vhpt_invalidate_all(void)
 {
 	memsetb(vhpt_base, VHPT_SIZE, 0);
Index: kernel/arch/mips32/src/debugger.c
===================================================================
--- kernel/arch/mips32/src/debugger.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/arch/mips32/src/debugger.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -288,5 +288,5 @@
  *
  */
-void debugger_init()
+void debugger_init(void)
 {
 	unsigned int i;
Index: kernel/arch/mips32/src/fpu_context.c
===================================================================
--- kernel/arch/mips32/src/fpu_context.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/arch/mips32/src/fpu_context.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -53,5 +53,5 @@
 }
 
-void fpu_init()
+void fpu_init(void)
 {
 	/* TODO: Zero all registers */
Index: kernel/arch/sparc32/src/sparc32.c
===================================================================
--- kernel/arch/sparc32/src/sparc32.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/arch/sparc32/src/sparc32.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -96,5 +96,5 @@
 
 
-void arch_post_cpu_init()
+void arch_post_cpu_init(void)
 {
 }
Index: kernel/generic/include/lib/memfnc.h
===================================================================
--- kernel/generic/include/lib/memfnc.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/generic/include/lib/memfnc.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -46,6 +46,8 @@
 
 extern void *memset(void *, int, size_t)
+    __attribute__((nonnull(1)))
     ATTRIBUTE_OPTIMIZE("-fno-tree-loop-distribute-patterns") DO_NOT_DISCARD;
 extern void *memcpy(void *, const void *, size_t)
+    __attribute__((nonnull(1, 2)))
     ATTRIBUTE_OPTIMIZE("-fno-tree-loop-distribute-patterns") DO_NOT_DISCARD;
 
Index: kernel/generic/include/memstr.h
===================================================================
--- kernel/generic/include/memstr.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/generic/include/memstr.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -48,7 +48,10 @@
 #define memcpy(dst, src, cnt)  __builtin_memcpy((dst), (src), (cnt))
 
-extern void memsetb(void *, size_t, uint8_t);
-extern void memsetw(void *, size_t, uint16_t);
-extern void *memmove(void *, const void *, size_t) DO_NOT_DISCARD;
+extern void memsetb(void *, size_t, uint8_t)
+    __attribute__((nonnull(1)));
+extern void memsetw(void *, size_t, uint16_t)
+    __attribute__((nonnull(1)));
+extern void *memmove(void *, const void *, size_t)
+    __attribute__((nonnull(1, 2))) DO_NOT_DISCARD;
 
 #endif
Index: kernel/generic/include/mm/slab.h
===================================================================
--- kernel/generic/include/mm/slab.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/generic/include/mm/slab.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -142,5 +142,6 @@
 extern void *malloc(size_t, unsigned int)
     __attribute__((malloc));
-extern void *realloc(void *, size_t, unsigned int);
+extern void *realloc(void *, size_t, unsigned int)
+    __attribute__((warn_unused_result));
 extern void free(void *);
 
Index: kernel/generic/include/typedefs.h
===================================================================
--- kernel/generic/include/typedefs.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/generic/include/typedefs.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -50,5 +50,5 @@
 } atomic_t;
 
-typedef void (* function)();
+typedef void (* function)(void);
 
 typedef uint32_t container_id_t;
Index: kernel/generic/src/ipc/ops/conctmeto.c
===================================================================
--- kernel/generic/src/ipc/ops/conctmeto.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/generic/src/ipc/ops/conctmeto.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -44,4 +44,6 @@
 	int newphid = phone_alloc(TASK);
 
+	/* Remember the phoneid or the error. */
+	call->priv = newphid;
 	if (newphid < 0)
 		return ELIMIT;
@@ -49,5 +51,4 @@
 	/* Set arg5 for server */
 	IPC_SET_ARG5(call->data, (sysarg_t) &TASK->phones[newphid]);
-	call->priv = newphid;
 
 	return EOK;
@@ -73,8 +74,17 @@
 static int answer_process(call_t *answer)
 {
-	if (IPC_GET_RETVAL(answer->data))
-		phone_dealloc(answer->priv);
-	else
-		IPC_SET_ARG5(answer->data, answer->priv);
+	int newphid = (int) answer->priv;
+
+	if (IPC_GET_RETVAL(answer->data)) {
+		if (newphid >= 0) {
+			/*
+			 * The phone was indeed allocated and now needs
+			 * to be deallocated.
+			 */
+			phone_dealloc(newphid);
+		}
+	} else {
+		IPC_SET_ARG5(answer->data, newphid);
+	}
 	
 	return EOK;
Index: kernel/generic/src/lib/func.c
===================================================================
--- kernel/generic/src/lib/func.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/generic/src/lib/func.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -51,5 +51,5 @@
  *
  */
-void halt()
+void halt(void)
 {
 #if (defined(CONFIG_DEBUG)) && (defined(CONFIG_KCONSOLE))
Index: kernel/generic/src/mm/as.c
===================================================================
--- kernel/generic/src/mm/as.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/generic/src/mm/as.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -834,12 +834,12 @@
 			if ((cond = (bool) node->keys)) {
 				uintptr_t ptr = node->key[node->keys - 1];
-				size_t size =
+				size_t node_size =
 				    (size_t) node->value[node->keys - 1];
 				size_t i = 0;
 				
-				if (overlaps(ptr, P2SZ(size), area->base,
+				if (overlaps(ptr, P2SZ(node_size), area->base,
 				    P2SZ(pages))) {
 					
-					if (ptr + P2SZ(size) <= start_free) {
+					if (ptr + P2SZ(node_size) <= start_free) {
 						/*
 						 * The whole interval fits
@@ -860,5 +860,5 @@
 					i = (start_free - ptr) >> PAGE_WIDTH;
 					if (!used_space_remove(area, start_free,
-					    size - i))
+					    node_size - i))
 						panic("Cannot remove used space.");
 				} else {
@@ -867,5 +867,5 @@
 					 * completely removed.
 					 */
-					if (!used_space_remove(area, ptr, size))
+					if (!used_space_remove(area, ptr, node_size))
 						panic("Cannot remove used space.");
 				}
@@ -887,5 +887,5 @@
 				    area->pages - pages);
 		
-				for (; i < size; i++) {
+				for (; i < node_size; i++) {
 					pte_t *pte = page_mapping_find(as,
 					    ptr + P2SZ(i), false);
Index: kernel/generic/src/mm/slab.c
===================================================================
--- kernel/generic/src/mm/slab.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/generic/src/mm/slab.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -610,4 +610,6 @@
     unsigned int kmflag), size_t (*destructor)(void *obj), unsigned int flags)
 {
+	ASSERT(size > 0);
+	
 	memsetb(cache, sizeof(*cache), 0);
 	cache->name = name;
@@ -888,5 +890,5 @@
 	/* Initialize magazine cache */
 	_slab_cache_create(&mag_cache, "slab_magazine_t",
-	    sizeof(slab_magazine_t) + SLAB_MAG_SIZE * sizeof(void*),
+	    sizeof(slab_magazine_t) + SLAB_MAG_SIZE * sizeof(void *),
 	    sizeof(uintptr_t), NULL, NULL, SLAB_CACHE_NOMAGAZINE |
 	    SLAB_CACHE_SLINSIDE);
Index: kernel/generic/src/synch/futex.c
===================================================================
--- kernel/generic/src/synch/futex.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/generic/src/synch/futex.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -400,5 +400,13 @@
 		return (sysarg_t) ENOENT;
 
+#ifdef CONFIG_UDEBUG
+	udebug_stoppable_begin();
+#endif
+
 	int rc = waitq_sleep_timeout(&futex->wq, 0, SYNCH_FLAGS_INTERRUPTIBLE); 
+
+#ifdef CONFIG_UDEBUG
+	udebug_stoppable_end();
+#endif
 
 	return (sysarg_t) rc;
Index: kernel/generic/src/udebug/udebug_ops.c
===================================================================
--- kernel/generic/src/udebug/udebug_ops.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ kernel/generic/src/udebug/udebug_ops.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -375,4 +375,5 @@
 	if (TASK->udebug.dt_state != UDEBUG_TS_ACTIVE) {
 		mutex_unlock(&TASK->udebug.lock);
+		free(id_buffer);
 		return EINVAL;
 	}
@@ -456,7 +457,4 @@
 int udebug_args_read(thread_t *thread, void **buffer)
 {
-	/* Prepare a buffer to hold the arguments. */
-	sysarg_t *arg_buffer = malloc(6 * sizeof(sysarg_t), 0);
-	
 	/* On success, this will lock t->udebug.lock. */
 	int rc = _thread_op_begin(thread, false);
@@ -471,4 +469,7 @@
 	}
 	
+	/* Prepare a buffer to hold the arguments. */
+	sysarg_t *arg_buffer = malloc(6 * sizeof(sysarg_t), 0);
+	
 	/* Copy to a local buffer before releasing the lock. */
 	memcpy(arg_buffer, thread->udebug.syscall_args, 6 * sizeof(sysarg_t));
@@ -499,7 +500,4 @@
 int udebug_regs_read(thread_t *thread, void **buffer)
 {
-	/* Prepare a buffer to hold the data. */
-	istate_t *state_buf = malloc(sizeof(istate_t), 0);
-	
 	/* On success, this will lock t->udebug.lock */
 	int rc = _thread_op_begin(thread, false);
@@ -512,4 +510,7 @@
 		return EBUSY;
 	}
+	
+	/* Prepare a buffer to hold the data. */
+	istate_t *state_buf = malloc(sizeof(istate_t), 0);
 	
 	/* Copy to the allocated buffer */
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/Makefile	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -77,9 +77,4 @@
 	app/usbinfo \
 	app/vuhid \
-	app/netecho \
-	app/netspeed \
-	app/nettest1 \
-	app/nettest2 \
-	app/nettest3 \
 	app/nic \
 	app/ping \
@@ -235,5 +230,5 @@
 	lib/draw \
 	lib/math \
-	lib/net \
+	lib/nettl \
 	lib/nic \
 	lib/ext4 \
Index: uspace/Makefile.common
===================================================================
--- uspace/Makefile.common	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/Makefile.common	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -142,5 +142,4 @@
 LIBHOUND_PREFIX = $(LIB_PREFIX)/hound
 LIBPCM_PREFIX = $(LIB_PREFIX)/pcm
-LIBNET_PREFIX = $(LIB_PREFIX)/net
 LIBNIC_PREFIX = $(LIB_PREFIX)/nic
 LIBIEEE80211_PREFIX = $(LIB_PREFIX)/ieee80211
@@ -158,4 +157,5 @@
 LIBMBR_PREFIX = $(LIB_PREFIX)/mbr
 LIBGPT_PREFIX = $(LIB_PREFIX)/gpt
+LIBNETTL_PREFIX = $(LIB_PREFIX)/nettl
 
 LIBURCU_PREFIX = $(LIB_PREFIX)/urcu
@@ -264,5 +264,5 @@
 
 ifeq ($(CONFIG_LINE_DEBUG),y)
-	GCC_CFLAGS += -g
+	GCC_CFLAGS += -ggdb
 	ICC_CFLAGS += -g
 	CLANG_CFLAGS += -g
Index: uspace/app/bdsh/cmds/modules/cat/cat.c
===================================================================
--- uspace/app/bdsh/cmds/modules/cat/cat.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/app/bdsh/cmds/modules/cat/cat.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -108,5 +108,5 @@
 }
 
-static void waitprompt()
+static void waitprompt(void)
 {
 	console_set_pos(console, 0, console_rows-1);
@@ -120,5 +120,5 @@
 }
 
-static void waitkey()
+static void waitkey(void)
 {
 	cons_event_t ev;
@@ -149,5 +149,5 @@
 }
 
-static void newpage()
+static void newpage(void)
 {
 	console_clear(console);
Index: uspace/app/bdsh/input.c
===================================================================
--- uspace/app/bdsh/input.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/app/bdsh/input.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -219,5 +219,5 @@
 }
 
-void print_pipe_usage()
+void print_pipe_usage(void)
 {
 	printf("Invalid syntax!\n");
Index: uspace/app/download/main.c
===================================================================
--- uspace/app/download/main.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/app/download/main.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -36,4 +36,5 @@
  */
 
+#include <errno.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -42,8 +43,4 @@
 #include <task.h>
 #include <macros.h>
-
-#include <net/in.h>
-#include <net/inet.h>
-#include <net/socket.h>
 
 #include <http/http.h>
Index: uspace/app/nterm/conn.c
===================================================================
--- uspace/app/nterm/conn.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/app/nterm/conn.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -38,6 +38,6 @@
 #include <fibril.h>
 #include <inet/dnsr.h>
-#include <net/inet.h>
-#include <net/socket.h>
+#include <inet/endpoint.h>
+#include <inet/tcp.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -48,54 +48,63 @@
 #include "nterm.h"
 
-static int conn_fd;
-static fid_t rcv_fid;
+static tcp_t *tcp;
+static tcp_conn_t *conn;
 
 #define RECV_BUF_SIZE 1024
 static uint8_t recv_buf[RECV_BUF_SIZE];
 
-static int rcv_fibril(void *arg)
+static void conn_conn_reset(tcp_conn_t *);
+static void conn_data_avail(tcp_conn_t *);
+
+static tcp_cb_t conn_cb = {
+	.conn_reset = conn_conn_reset,
+	.data_avail = conn_data_avail
+};
+
+static void conn_conn_reset(tcp_conn_t *conn)
 {
-	ssize_t nr;
+	printf("\n[Connection reset]\n");
+}
+
+static void conn_data_avail(tcp_conn_t *conn)
+{
+	int rc;
+	size_t nrecv;
 
 	while (true) {
-		nr = recv(conn_fd, recv_buf, RECV_BUF_SIZE, 0);
-		if (nr < 0)
+		rc = tcp_conn_recv(conn, recv_buf, RECV_BUF_SIZE, &nrecv);
+		if (rc != EOK) {
+			printf("\n[Receive error %d]\n", rc);
 			break;
+		}
 
-		nterm_received(recv_buf, nr);
+		nterm_received(recv_buf, nrecv);
+
+		if (nrecv != RECV_BUF_SIZE)
+			break;
 	}
-
-	if (nr == ENOTCONN)
-		printf("\n[Other side has closed the connection]\n");
-	else
-		printf("'\n[Receive errror (%s)]\n", str_error(nr));
-
-	exit(0);
-	return 0;
 }
 
 int conn_open(const char *host, const char *port_s)
 {
-	int conn_fd = -1;
-	struct sockaddr *saddr = NULL;
-	socklen_t saddrlen;
-	
+	inet_ep2_t epp;
+
 	/* Interpret as address */
 	inet_addr_t iaddr;
 	int rc = inet_addr_parse(host, &iaddr);
-	
+
 	if (rc != EOK) {
 		/* Interpret as a host name */
 		dnsr_hostinfo_t *hinfo = NULL;
 		rc = dnsr_name2host(host, &hinfo, ip_any);
-		
+
 		if (rc != EOK) {
 			printf("Error resolving host '%s'.\n", host);
 			goto error;
 		}
-		
+
 		iaddr = hinfo->addr;
 	}
-	
+
 	char *endptr;
 	uint16_t port = strtol(port_s, &endptr, 10);
@@ -104,37 +113,28 @@
 		goto error;
 	}
-	
-	rc = inet_addr_sockaddr(&iaddr, port, &saddr, &saddrlen);
-	if (rc != EOK) {
-		assert(rc == ENOMEM);
-		printf("Out of memory.\n");
-		return ENOMEM;
-	}
-	
+
+	inet_ep2_init(&epp);
+	epp.remote.addr = iaddr;
+	epp.remote.port = port;
+
 	printf("Connecting to host %s port %u\n", host, port);
-	
-	conn_fd = socket(saddr->sa_family, SOCK_STREAM, 0);
-	if (conn_fd < 0)
-		goto error;
-	
-	rc = connect(conn_fd, saddr, saddrlen);
+
+	rc = tcp_create(&tcp);
 	if (rc != EOK)
 		goto error;
-	
-	rcv_fid = fibril_create(rcv_fibril, NULL);
-	if (rcv_fid == 0)
+
+	rc = tcp_conn_create(tcp, &epp, &conn_cb, NULL, &conn);
+	if (rc != EOK)
 		goto error;
-	
-	fibril_add_ready(rcv_fid);
-	
-	free(saddr);
+
+	rc = tcp_conn_wait_connected(conn);
+	if (rc != EOK)
+		goto error;
+
 	return EOK;
 error:
-	if (conn_fd >= 0) {
-		closesocket(conn_fd);
-		conn_fd = -1;
-	}
-	free(saddr);
-	
+	tcp_conn_destroy(conn);
+	tcp_destroy(tcp);
+
 	return EIO;
 }
@@ -142,8 +142,8 @@
 int conn_send(void *data, size_t size)
 {
-	int rc = send(conn_fd, data, size, 0);
+	int rc = tcp_conn_send(conn, data, size);
 	if (rc != EOK)
 		return EIO;
-	
+
 	return EOK;
 }
Index: uspace/app/trace/trace.c
===================================================================
--- uspace/app/trace/trace.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/app/trace/trace.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -730,5 +730,5 @@
 }
 
-static void print_syntax()
+static void print_syntax(void)
 {
 	printf("Syntax:\n");
